function s = removefields(s, varargin)


% Part of PFCMP version 2.5.41, an extension to the PSIGNIFIT toolbox for MATLAB versions 5 and up.
% The license and NO WARRANTY statement for PSIGNIFIT also applies to this release - see psych_legal.m
% Copyright (c) J.Hill 2002.
% mailto:psignifit@bootstrap-software.org
% http://www.bootstrap-software.org/psignifit/

if length(varargin) == 1
	arg = varargin{1};
	if iscellstr(arg) | (ischar(arg) & size(arg, 1) ~= 1)
		varargin = arg;
	end
end
fields = cellstr(varargin);
cleanup = {};
for i = 1:length(fields)
	field = ['s.' fields{i}];
	lastdot = max(find(field == '.'));
	stem = field(1:lastdot-1);
	last = field(lastdot+1:end);
	eval([stem ' = rmfield(' stem ', ''' last ''');'], '')
	remainder = eval(stem);
	if isequal(remainder, []) & ~isequal(stem, 's')
		cleanup{end+1} = stem(3:end);
	end
end
if ~isempty(cleanup)
	s = removefields(s, cleanup);
end
